%{
   /* Pequeno Analisador Lexico de programas Pascal */

#include "y.tab.h"
#include "string.h"

#define OK 1
#define KO 0

%}

NQUOTE    [^']

%%

%{

char c;
int kw;

%}

"AND"		return(KW_AND);
"ARRAY"     return(KW_ARRAY);  
"BEGIN"     return(KW_BEGIN);        
"CASE"      return(KW_CASE);      
"CONST"     return(KW_CONST); 
"DIV"       return(KW_DIV);       
"DO"        return(KW_DO);     
"DOWNTO"    return(KW_DOWNTO);  
"ELSE"      return(KW_ELSE);      
"END"       return(KW_END); 
"EXTERNAL"  return(KW_EXTERNAL);  
"FILE"	return(KW_FILE);   
"FOR"       return(KW_FOR);     
"FORWARD"	return(KW_FORWARD);   
"FUNCTION"  return(KW_FUNCTION);    
"GOTO"      return(KW_GOTO);      
"IF"        return(KW_IF);    
"IN"        return(KW_IN);    
"LABEL"     return(KW_LABEL);  
"MOD"       return(KW_MOD);    
"NIL"       return(KW_NIL);    
"NOT"       return(KW_NOT);       
"OF"        return(KW_OF);     
"OR"        return(KW_OR);      
"OTHERWISE" return(KW_OTHERWISE); 
"PACKED"    return(KW_PACKED);    
"PROCEDURE" return(KW_PROCEDURE);         
"PROGRAM"   return(KW_PROGRAM); 
"RECORD"    return(KW_RECORD);    
"REPEAT"    return(KW_REPEAT);    
"SET"       return(KW_SET);               
"THEN"      return(KW_THEN);    
"TO"        return(KW_TO);        
"TYPE"      return(KW_TYPE);              
"UNTIL"     return(KW_UNTIL);     
"VAR"       return(KW_VAR); 
"WHILE"     return(KW_WHILE);    
"WITH"      return(KW_WITH);
  
[a-zA-Z]([a-zA-Z0-9])*	return(IDENTIFIER);
":="			return(ASSIGNMENT);
'({NQUOTE}|'')+'	return(CHARACTER_STRING);
":"			return(COLON);
","			return(COMMA);
[0-9]+		return(DIGSEQ);
"."			return(DOT);
".."			return(DOTDOT);
"="			return(EQUAL);
">="			return(GE);
">"			return(GT);
"["			return(LBRAC);
"<="			return(LE);
"("			return(LPAREN);
"<"			return(LT);
"-"			return(MINUS);
"<>"			return(NOTEQUAL);
"+"			return(PLUS);
"]"			return(RBRAC);
[0-9]+"."[0-9]+	return(REALNUMBER);
")"			return(RPAREN);
";"			return(SEMICOLON);
"/"			return(SLASH);
"*"			return(STAR);
"**"			return(STARSTAR);
"->"            	|
"^"			return(UPARROW);

"(*"[^"*)"]"*)"   |
"{"[^"}"]"}"	;
[ \n\t\f]		;

.			return(ILLEGAL);
